Subject: bug#19620: 25.0.50; Eieio constructor behaviour changed and broke pcache.el

From: Kirill Ignatiev <[email-masked]>
Date: Fri, 16 Jan 2015 23:56:05 -0500

The following code (essentially taken from pcache.el) used to work
fine until recently (worked fine in 24.4 and in some recent git head),
but gives a wrong-number-of-arguments error in current git head:

(require 'eieio)
(require 'eieio-generic)

(defclass testing ()
  ())

(defmethod constructor :static ((x testing) newname &rest args)
  (message "Constructor")
  (call-next-method))

(testing "test")

I haven't really used eieio, so I can't be sure what went wrong. Emacs
used to accept this code and run this without errors, so I assume the
code is actually correct.